#ifndef plugin_propertieswindowH
#define plugin_propertieswindowH

#include <windows.h>

#include "plugin_contactlist_defs.h"

typedef struct {

  int structSize;		//wielko struktury w bajtach

  HANDLE Handle;                //Suy do atwych zmian potem (caption, contact)

  char *WindowCaption;
  TlenSingleImageDef WindowIcon;

  int WindowType;

  char *DefaultPageID;          //ID zakadki, ktr wywietli po stworzeniu okna
  int Flags;

  ContactDef Contact;          //W przypadku properties id kontaktu i protokolu, jesli addwindow, to tylko protocolID jest valid (albo oba, vide dodawanie kontaktu tlenu, ktory nie ma autoryzacji)
  char *ContactName;           //Gdy dodajemy kontakt, to taki string powinien umiescic w polu nazwa na liscie

  void *OwnerData;
} TlenPropertiesWindowInfoDef;

#define TLEN_PROPERTIESWINDOW_WINDOWTYPE_PROPERTIES     1
#define TLEN_PROPERTIESWINDOW_WINDOWTYPE_ADDCONTACT     2

#define TLEN_PROPERTIESWINDOW_FLAG_OKBUTTON             0x0001
#define TLEN_PROPERTIESWINDOW_FLAG_APPLYBUTTON          0x0002
#define TLEN_PROPERTIESWINDOW_FLAG_CANCELBUTTON         0x0004
#define TLEN_PROPERTIESWINDOW_FLAG_SEARCHBUTTON         0x0008
#define TLEN_PROPERTIESWINDOW_FLAG_ADDBUTTON            0x0010

#define TLEN_PROPERTIESWINDOW_FLAG_SIMPLEWINDOW         0x0100

typedef struct {

 int structSize;

 char *PageID;
 char *ParentID; //jesli ma to byc w formie drzewa

 char *Name;

 int Flags;

 int Position; //kolejnosc na liscie, na razie nieuzywana
 TlenSingleImageDef Icon; //Ikonka, ktora narysowac na liscie.

 TLENFUNCTION CallBackFunction; //funkcje ktora wywolac przy zdarzeniach

 void *OwnerData;

} TlenPropertiesPageDefinition;

#define TLEN_PROPERTIESPAGE_FLAG_TLENCOLOR     1
#define TLEN_PROPERTIESPAGE_FLAG_ICONTRANS     2
#define TLEN_PROPERTIESPAGE_FLAG_BMODE         4

typedef struct {

 int structSize;

 TlenPropertiesPageDefinition *Page; //kliknita zakadka
 TlenPropertiesWindowInfoDef *WinInfo; //Info o oknie w ktrym to kliknito

 int Action; //akcja

 HWND Handle; //w tym oknie umieci dialog
 int x; //w tej pozycji
 int y;
 int width; //takie rozmiary
 int height;
 COLORREF bgColor; //kolor ta okienka tlenowego

 int Flags;

 //dane OUT
 char Caption[256];
 char Description[1024];
 TlenSingleImageDef Icon;
 int UserFlag;

} TlenPropertiesPageShowInfo;

#define TLEN_PROPERTIESPAGESHOW_FLAG_ICONTRANS    0x0000001
#define TLEN_PROPERTIESPAGESHOW_FLAG_DESTROYPAGE  0x1000000

#define TLEN_PROPERTIESPAGESHOW_ACTION_SHOW           1
#define TLEN_PROPERTIESPAGESHOW_ACTION_HIDE           2
#define TLEN_PROPERTIESPAGESHOW_ACTION_DESTROY        3
#define TLEN_PROPERTIESPAGESHOW_ACTION_OK             4
#define TLEN_PROPERTIESPAGESHOW_ACTION_APPLY          5
#define TLEN_PROPERTIESPAGESHOW_ACTION_CANCEL         6
#define TLEN_PROPERTIESPAGESHOW_ACTION_ADD            7
#define TLEN_PROPERTIESPAGESHOW_ACTION_SEARCH         8
#define TLEN_PROPERTIESPAGESHOW_ACTION_CONTACTCHANGE  9
#define TLEN_PROPERTIESPAGESHOW_ACTION_ADVANCED       10

#define TLEN_PROPERTIESPAGESHOW_USERFLAG_NOSEARCH     0x0000001
//HOOK:
//Wszystkie moduly, ktore podepna sie pod ten hook beda mogly dodac swoje zakladki
//po wywolaniu okna, tuz przed jego pokazaniem.
#define TLEN_PROPERTIES_EVENT_ADDPAGES            "Tlen/PropertiesAddPages"
//WPARAM: TlenPropertiesWindowInfoDef *
//LPARAM: void * - przekazac do PAGEADD

#define TLEN_PROPERTIES_PAGEADD                   "Tlen/PropertiesPageAdd"
//WPARAM: TlenPropertiesPageDefinition *
//LPARAM: void * - z Hooka

#define TLEN_PROPERTIES_PERFORM_ACTION            "Tlen/PropertiesPerformAction"
//WPARAM - ACTION

#define TLEN_PROPERTIES_ACTION_SHOW           1
//LPARAM: TlenPropertiesWindowInfoDef *

#define TLEN_PROPERTIES_ACTION_CHANGEDATA     2
//LPARAM: TlenPropertiesWindowInfoDef *

//ID - zakladki tlenowe
#define PROPERTIES_PAGE_TLENEDITCONTACT         "Tlen/EditContact"
#define PROPERTIES_PAGE_TLENADDCONTACT          "Tlen/AddContact"
#define PROPERTIES_PAGE_GGEDITCONTACT           "GG/EditContact"
#define PROPERTIES_PAGE_GGADDCONTACT            "GG/AddContact"
#define PROPERTIES_PAGE_SMSEDITCONTACT          "SMS/EditContact"
#define PROPERTIES_PAGE_SMSADDCONTACT           "SMS/AddContact"
#define PROPERTIES_PAGE_GENERALEDITCONTACT      "General/EditContact"
#define PROPERTIES_PAGE_GENERALADDCONTACT       "General/AddContact"

//--------------------------------------------------------------------------
//Dodawanie kontaktu

#define TLEN_ADDCONTACTWINDOW_SHOW              "Tlen/AddContactWindow/Show"

#endif
